<template>
	<view class="p-root-detail-fellow g_w_all g_h_all g_bg_f_5 g_kuaishou">
		<view v-if="speed == 0">
			<rh-loading />
		</view>
		<view v-if="speed == 1">
			<view class="g_h_10"></view>
			<!-- <view class="m-photo">
				<g-panel-card-info
					:info="{
						avatar: cdnBaseImg + 'mock_photo.svg',
						title: '拍照或相册上传',
						num: '系统智能识别并自动填写',
						titleFS: 16,
						imgSize: 72,
					}"
					radius="0"
					rightType="image"
					:rightImage="info.idCardImageUrl"
					@clickCard="handleClickInfo"
				/>
			</view>
			<view class="g_h_10"></view> -->
			<g-panel-form-slot :list="telList" @changeWeChat="handleChangeWeChat" @changeMobile="handleClickMobile"></g-panel-form-slot>
			<view class="g_h_10"></view>
			<g-panel-form-slot
				:list="[
					{
						icon: '',
						label: '姓名',
						result: '',
						value: info.name,
						path: '',
						tip: 'slot-upID',
						img: info.idCardImageUrl,
						placeholder: '手动输入或拍照自动识别 → ',
						type: 'slot',
						pColumn: 12,
						require: true,
					},
					{
						icon: '',
						label: '身份证号',
						result: '',
						value: info.idCard,
						path: '',
						tip: 'slot-code-idcard',
						placeholder: '请输入身份证号',
						type: 'slot',
						pColumn: 12,
					},
					{
						icon: '',
						label: '性别',
						result: '',
						value: info.sex,
						path: '',
						tip: 'slot-sex',
						type: 'slot',
						pColumn: 12,
						require: false,
						customRequire: false,
					},
					{
						icon: '',
						label: '年龄',
						result: '',
						value: info.age,
						path: '',
						tip: 'slot-age',
						placeholder: '请输入年龄',
						type: 'slot',
						pColumn: 12,
						require: false,
					},
					{
						icon: '',
						label: '民族',
						result: '',
						value: info.nation,
						nationIndex: nationIndex,
						path: '',
						tip: 'slot-nation',
						pColumn: 12,
						type: 'slot',
					},

					{
						icon: '',
						label: '身份证住址',
						result: '',
						value: info.address,
						placeholder: '请输入身份证住址',
						path: '',
						tip: 'slot-address',
						type: 'slot',
						pColumn: 12,
					},
				]"
				@changeName="handleClickName"
				@changeSex="handleClickSex"
				@changeAge="handleClickAge"
				@changeNation="handleClickNation"
				@changeIDcard="handleClickIDcard"
				@changeAddress="handleClickAddress"
				@updateIDInfo="handlerIDInfo"
				@updateFile="updateFile"
			>
				<!-- {
						icon: '',
						label: '上传附件',
						result: '',
						path: '',
						type: 'slot',
						tip: 'slot-update-file',
						pColumn: 16,
					}, -->
				<template v-slot:after>
					<view class="g_flex_row_start g_p_10" v-if="imgList.length > 0">
						<view v-for="(item, index) in imgList" class="g_position_rela" :class="index <= 2 ? 'g_mr_18' : ''" :key="index">
							<i class="iconfont icon-guanbi img-close" @click="delImg(index)"></i>
							<image :src="item" class="g_w_56 g_h_56 g_radius_8" />
						</view>
					</view>
				</template>
			</g-panel-form-slot>
			<g-panel-fixed>
				<slot>
					<view class="g_pl_12 g_pr_12">
						<!-- <rh-button  btnText="取消" class="g_mr_16" size="small" type="default" @clickBtn="goReturn"></rh-button> -->
						<rh-button  btnText="确定" class=" " @clickBtn="handleSubmit" size="auto" type="primary"></rh-button>
					</view>
				</slot>
			</g-panel-fixed>
		</view>
	</view>
</template>

<script>
import { nationlist } from "../utils/nation.js";
export default {
	components: {
	},
	onReady() {
		this.G.setNavStyle();
	},
	onShareAppMessage() {
		return this.G.shareFun();
	},
	data() {
		return {
			cdnBaseImg: this.G.store().cdnBaseImg,
			speed: 0,
			info: {},
			nation: nationlist.map((item, index) => {
				return item.name;
			}),
			nationIndex: 0,
			imgList: [],
			telList: [],
			pageType: "",
			resumeFlag: 0,
		};
	},
	onLoad(options) {
		let that = this;
		console.log("info", this.info);
		console.log("options", options);
		if (options.sex) {
			options.sex = Number(options.sex);
		} else {
			options.sex = 1;
		}
		if (!options.nation) {
			options.nation = "汉族";
		}
		if (options.type == "add") {
			this.pageType = "add";
			this.resumeFlag = 1;
		} else {
			this.info = options;
		}

		console.log("获取老乡信息：", options);
		if (this.info.imgs) {
			this.imgList = this.info.imgs.split(",");
		}
	},
	onShow() {
		let that = this;
		console.log("info", this.info);
		console.log("telList", this.telList);
		this.telList = [
			{
				icon: "",
				label: "手机号",
				result: "",
				path: "",
				value: this.info.tel,
				tip: "slot-mobile",
				placeholder: "请输入手机号",
				type: "slot",
				pColumn: 8,
				require: true,
			},
		];

		if (this.info.resumeFlag == 1 || this.resumeFlag == 1) {
			this.telList.push({
				icon: "",
				label: "微信",
				result: "",
				path: "",
				value: this.info.weChat,
				tip: "slot-weChat",
				placeholder: "请输入联系微信",
				type: "slot",
				pColumn: 8,
				require: true,
			});
		}
		that.nation.forEach((item, index) => {
			if (item == that.info.nation) {
				console.log(that.info.nation);
				console.log(index);
				that.nationIndex = index;
			}
		});
		that.speed = 0;
		setTimeout(() => {
			that.speed = 1;
		}, 300);
	},
	created() {
		let that = this;
	},
	methods: {
		handleClickName(e) {
			this.info.name = this.info.userName = e;
		},
		handleClickSex(e) {
			this.info.sex = e;
		},
		handleClickAge(e) {
			this.info.age = e;
		},
		handleClickNation(e) {
			let that = this;
			console.log(e.name);
			this.info.nation = e.name;
			that.nation.forEach((item, index) => {
				if (item == e.name) {
					// console.log(that.info.nation)
					// console.log(index)
					that.nationIndex = index;
				}
			});
		},
		handleClickNation(e) {
			let that = this;
			console.log(e.name);
			this.info.nation = e.name;
			that.nation.forEach((item, index) => {
				if (item == e.name) {
					// console.log(that.info.nation)
					// console.log(index)
					that.nationIndex = index;
				}
			});
		},
		handleClickIDcard(e) {
			this.info.idCard = e;
		},
		handleClickAddress(e) {
			this.info.address = e;
		},
		goReturn() {
			uni.navigateBack();
		},
		handleSubmit() {
			let that = this;
			if (this.info.resumeFlag == 1 || this.resumeFlag == 1) {
				if (!that.info.tel && !that.info.weChat) {
					uni.showToast({
						icon: "none",
						title: "请输入手机号或微信",
					});
					return false;
				}
			} else {
				if (!that.info.tel) {
					uni.showToast({
						icon: "none",
						title: "请输入手机号",
					});
					return false;
				}
			}

			if (that.info.tel && !that.G.setReg(that.info.tel, "tel")) {
				uni.showToast({
					icon: "none",
					title: "请输入正确的手机号",
				});
				return false;
			}

			if (that.info.idCard && !that.G.setReg(that.info.idCard, "idcard")) {
				uni.showToast({
					icon: "none",
					title: "请输入正确的身份证号",
				});
				return false;
			}
			// if (that.imgList.length > 0) {
			// 	that.info.imgs = that.imgList;
			// }
			if (!that.info.nation) {
				that.info.nation = "汉族";
			}
			let url = "";
			if (this.pageType == "add") {
				url = "add_resume";
				that.info.followUserId = uni.getStorageSync("apply-userinfo").id;
			} else {
				url = "order_submitFellow";
			}
			that.G.Post(that.api[url], that.info, (res) => {
				uni.showToast({
					icon: "success",
					title: this.pageType == "add" ? "新建成功" : "保存成功",
				});
				if (this.pageType == "add") {
					that.goReturn();
					setTimeout(() => {
						uni.$emit("goNew");
					}, 100);
				} else {
					setTimeout(() => {
						that.goReturn();
					}, 300);
				}
			});
		},
		handleClickInfo() {
			let that = this;
			that.G.uploadImg((res) => {
				that.info.name = res.info.name;
				that.info.sex = res.info.sex;
				that.info.age = res.info.age;
				that.info.nation = res.info.nationality;
				that.info.idCard = res.info.num;
				that.info.idCardImageUrl = res.image;
				that.info.userName = res.info.name;
				that.info.address = res.info.address;
				that.nation.forEach((item, index) => {
					if (item == that.info.nation) {
						that.nationIndex = index;
					}
				});
			}, "idcard");
		},
		handleClickMobile(e) {
			console.log(e);
			this.info.tel = e;
		},

		handleChangeWeChat(e) {
			console.log(e);
			this.info.weChat = e;
		},

		// 删除图片
		delImg(ind) {
			this.imgList.splice(
				this.imgList.findIndex((item, index) => index == ind),
				1
			);
		},
		// 上传图片
		updateFile(e) {
			let that = this;
			if (that.imgList.length < 4) {
				that.imgList.push(e);
				uni.hideLoading();
			} else {
				uni.showToast({
					title: "最多只能上传4张",
					icon: "none",
				});
			}
		},
		/**
		 * 获取上传的身份信息
		 */
		handlerIDInfo(res) {
			console.log("res", res);
			let that = this;
			that.info.name = res.info.name;
			that.info.sex = res.info.sex ? (res.info.sex == "男" ? 1 : 2) : "";
			that.info.age = res.info.age;
			that.info.nation = res.info.nationality + "族";
			that.info.idCard = res.info.num;
			that.info.idCardImageUrl = res.image;
			that.info.userName = res.info.name;
			that.info.address = res.info.address;
			that.nation.forEach((item, index) => {
				// console.log("item1", item);
				// console.log('that.info.nation + "族"', that.info.nation + "族");
				if (item == that.info.nation) {
					console.log("item2", item);

					that.nationIndex = index;
				}
			});
			console.log("that.info", that.info);
			console.log("that.nationIndex", that.nationIndex);
			that.$forceUpdate();
		},
	},
};
</script>

<style></style>
